var uplinkGemini = require('./uplink-gemini');

var index = require('./routes/index');
var user_add = require('./routes/user').user_add;
var user_del = require('./routes/user').user_del;
var user = require('./routes/user').user;
var info = require('./routes/info');
var input = require('./routes/input');
var upload = require('./routes/upload');

const app = new uplinkGemini.App();
const gemini = new uplinkGemini.Gemini();

gemini.router.use('/user/add/:first/:last', user_add);
gemini.router.use('/user/del/:first/:last', user_del);
gemini.router.use('/info/:first', info);
gemini.router.use('/user', user);
gemini.router.use('/', index);
gemini.router.use('/input/', input);
gemini.router.use('/upload/', upload);

gemini.listen();

